#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "jheadlinestypes.h"
#include "callbacks.h"
#include "interface.h"
#include "network.h"
#include "support.h"

static void
show_current_time (void)
{
  GTimeVal  time;
  GDate    *date_heap;
  gchar     date[256], date_and_time[512];
  
  g_get_current_time (&time);
  
  date_heap = g_date_new ();
  g_date_set_time_val (date_heap, &time);
  g_date_strftime (date, 256, "%x", date_heap);

  // Japan: GMT+9, 24-hour clock
  sprintf (date_and_time, _("%s %02d:%02d Update"), date,
	   ((time.tv_sec % (3600 * 24)) / 3600 + 9) % 24,
	   (time.tv_sec % 3600) / 60);

  put_status_info ("(status clear)", NULL);
  //flash_status_info (date_and_time, NULL);
  put_status_info (date_and_time, NULL);

  g_date_free (date_heap);
}

gboolean
update_headlines (JhTarget *target)
{
  gchar *headline;

  while (target->url) {
    gtk_widget_set_sensitive (target->url_button, FALSE);
    if ((headline = get_headline (target)) == NULL) {
      g_warning ("Failed to get headline(url=%s)", target->url);
      put_status_info ("Failed: %s", target->url);
    } else {
      if (strncmp (headline, "(no change)", 11)) {
	if (headline[strlen (headline) - 2] == 13)
	  headline[strlen (headline) - 2] = '\0';
	else 
	  headline[strlen (headline) - 1] = '\0';
	gtk_entry_set_text (GTK_ENTRY (target->entry), headline);
      }
      gtk_entry_select_region (GTK_ENTRY (target->entry), 0, 0);
    }
    gtk_widget_set_sensitive (target->url_button, TRUE);

    target++;
  }

  show_current_time ();

  return TRUE;
}

void
on_update_headlines_activate (GtkWidget *w, JhTarget *target)
{
  update_headlines (target);
}

void
on_quit_activate (GtkMenuItem *menuitem, gpointer user_data)
{
  gtk_main_quit ();
}

void
on_url_button_enter (GtkWidget *w, gchar *url)
{
  put_status_info ("%s", url);
}

void
on_url_button_leave (GtkWidget *w, gchar *url)
{
  put_status_info ("(status clear)", NULL);
}

void
on_url_button_clicked (GtkWidget *w, gchar *url)
{
#ifdef BROWSER_OLD_STYLE
  static gboolean first = TRUE;
  gchar *browser, command[80];

#define JH_WWW_BROWSER "mozilla"

  browser = JH_WWW_BROWSER;

  if (!strncmp (browser, "kterm", 5)) {	/* using w3m */
    sprintf (command, "%s %s &", browser, url);
  } else {				/* netscape or mozilla */
    if (first) {
      sprintf (command, "%s %s &", browser, url);
      first = FALSE;
    } else {
      sprintf (command, "%s -remote 'openURL(%s)'", browser, url);
    }
  }

  system (command);
#else
  gnome_url_show (url, NULL);
#endif
}
