#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "jheadlinestypes.h"
#include "dialog_about.h"
#include "interface.h"
#include "pixmaps/window_icon.xpm"

static GtkWidget *
create_about (void)
{
  const gchar *authors[]     = { _("Maegawa Toshio"), NULL };
  const gchar *documenters[] = { NULL };
  gchar *translators         = _("Maegawa Toshio");
  GtkWidget *about;
  GdkPixbuf *icon;

  icon = gdk_pixbuf_new_from_xpm_data ((const char **) window_icon);
  about = gnome_about_new ("jheadlines", VERSION,
			   _("maegawa@jcom.home.ne.jp"),
			   _("Plesae mail me about this program."),
			   authors,
			   documenters,
			   translators,
			   icon);
  gtk_container_set_border_width (GTK_CONTAINER (about), 5);
  gtk_signal_connect (GTK_OBJECT (about), "realize",
		      GTK_SIGNAL_FUNC (set_window_icon), NULL);
  return about;
}

void
on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkWidget *about;
  about = create_about ();
  gtk_window_set_position (GTK_WINDOW (about), GTK_WIN_POS_CENTER);
  gtk_widget_show (about);
}
